import { createContext, useLayoutEffect, useState } from "react";

export const TaskContext = createContext(
  {
    tasks_ar:[{name:"",id:1}],
    currentEdit:{name:"",id:0},
    showEdit:false,
    showEditPopup:() => {}, 
    hideEditPopup:() => {},
    addTask:(item) => {},
    removeTask:(id) => {},
    editTask:(id,item) => {}
  }
);


export function TaksContextProvider({children}){
  const [tasks_ar,setTasksAr] = useState([
    {name:"go to work", id:1},
    {name:"go to eat", id:2}
  ])
  const [showEdit,setShowEdit] = useState(false)
  const [currentEdit,setCurrentEdit] = useState({name:"",id:0})

  useLayoutEffect(() => {
    if(localStorage.getItem("tasks")){
      setTasksAr(JSON.parse(localStorage.getItem("tasks")))
    }
  },[])

  const addTask = (item) => {
    setTasksAr((ar) => saveToLocal([...ar,item]));
    
  }

  const removeTask = (id) => {
    setTasksAr((ar) => saveToLocal(ar.filter(item => item.id != id)))
  }

  const editTask = (id,item) => {
    const taskIndex = tasks_ar.findIndex(item => item.id == id);
    const update_ar = [...tasks_ar];
    update_ar[taskIndex] = item;
    setTasksAr(saveToLocal(update_ar));
  }

  const saveToLocal = (newTask_ar) => {
    localStorage.setItem("tasks",JSON.stringify(newTask_ar))
    return newTask_ar;
  }

  const showEditPopup = (item) => {
    setCurrentEdit(item);
    setShowEdit(true);
  }

  const hideEditPopup = () => {
    setShowEdit(false);
  }
 
  const val = {
    showEdit, showEditPopup, hideEditPopup,
    currentEdit,
    tasks_ar,
    addTask,
    removeTask,
    editTask
  }




  return (
    <TaskContext.Provider value={val} >
      {children}
    </TaskContext.Provider>
  )
}